Bug 77762 - 2.4.18-17.7.x reports incorrect amount of processor cache
2.4.18-17.7.x reports incorrect amount of processor cache
Status: CLOSED CURRENTRELEASE
Product: Red Hat Linux
Classification: Retired
Component: kernel (Show other bugs)
7.3
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Arjan van de Ven
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-11-13 00:56 EST by Jim Wright
Modified: 2008-08-01 12:22 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2004-09-30 11:40:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
tyan s2518 with 2.4.18-3smp works as expected (814 bytes, text/plain)
2002-11-13 00:57 EST, Jim Wright
no flags Details
tyan s2518 with 2.4.18-177xsmp reports wrong cache size (910 bytes, text/plain)
2002-11-13 00:58 EST, Jim Wright
no flags Details
tyan s2688 with 2.4.18-177xbigmem reports wrong cache size (927 bytes, text/plain)
2002-11-13 00:59 EST, Jim Wright
no flags Details

  None (edit)
Description Jim Wright 2002-11-13 00:56:08 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.0.1) Gecko/20021003

Description of problem:
the 2.4.18-17.7.x kernel reports the incorrect amount of cache on certain
Pentium III processors.  booting with another Red Hat kernel confirms that only
this kernel incorrectly reports the cache size as 32KB.  with no changes to
hardware or firmware, other kernels report correct size.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.update kernel
2.cat /proc/cpuinfo

Actual Results:  cache size	: 32 KB


Expected Results:  cache size	: 512 KB


Additional info:

this does not affect performance, as we ran numerous benchmarks to confirm.  I
will attach output from /proc/cpuinfo for incorrect systems.

systems that report correct values include:

Supermicro P6SBA single Pentium III (Katmai)
Tyan S2720 dual Intel(R) XEON(TM) CPU 2.00GHz
Supermicro 370DER dual Pentium III (Coppermine)

systems with incorrect values include:

Tyan S2688 dual Intel(R) Pentium(R) III CPU family 1266MHz
Tyan S2518 dual Intel(R) Pentium(R) III CPU family 1266MHz
Comment 1 Jim Wright 2002-11-13 00:57:33 EST
Created attachment 84766 [details]
tyan s2518 with 2.4.18-3smp works as expected
Comment 2 Jim Wright 2002-11-13 00:58:09 EST
Created attachment 84767 [details]
tyan s2518 with 2.4.18-177xsmp reports wrong cache size
Comment 3 Jim Wright 2002-11-13 00:59:05 EST
Created attachment 84768 [details]
tyan s2688 with 2.4.18-177xbigmem reports wrong cache size
Comment 4 Jim Wright 2002-11-13 01:01:17 EST
I believe there are other boards which are affected by this, but that was what I
had immediately at hand.

also, I believe it is just a coincidence that both of my test systems have
1.266GHz processors, but I have not yet tested to confirm this suspicion.
Comment 5 Jim Wright 2002-11-13 01:04:11 EST
I was just looking at attachment (id=84768) and noticed that it is the first
time I can recall where an smp system reported identical clock speeds for the
two processors, but reported differing bogomips values.  probably completely
unrelated but strikes me as odd.
Comment 6 Radu Greab 2002-11-19 20:58:55 EST
What gives you the following (x86info is from kernel-utils)?
/usr/sbin/x86info -c

For me, on a PIII 1133MHz with 512 KB cache:

CPU #1
Family: 6 Model: 11 Stepping: 1 Type: 0 [Celeron / Pentium III (Tualatin) [tA1]
Original OEM]
[...]
unknown TLB/cache descriptor:
        0xc040883
[...]

Based on info from http://lists.insecure.org/linux-kernel/2002/Oct/0196.html
and http://developer.intel.com/design/xeon/applnots/241618.htm
I added descriptor 0x83 to x86info and now it gives a correct answer:

CPU #1
Family: 6 Model: 11 Stepping: 1 Type: 0 [Celeron / Pentium III (Tualatin) [tA1]
Original OEM]
[...]
L2 unified cache:
        Size: 512K      Sectored, 8 way associative.
        line size=32 bytes.
[...]

It looks like the 0x83 descriptor was already added to the list in newest
kernels, maybe RedHat would do the same for future kernel updates.
Comment 7 Bugzilla owner 2004-09-30 11:40:11 EDT
Thanks for the bug report. However, Red Hat no longer maintains this version of
the product. Please upgrade to the latest version and open a new bug if the problem
persists.

The Fedora Legacy project (http://fedoralegacy.org/) maintains some older releases, 
and if you believe this bug is interesting to them, please report the problem in
the bug tracker at: http://bugzilla.fedora.us/

Note You need to log in before you can comment on or make changes to this bug.